/*
 * File:   fundamental.c
 * Author: Kevin Schneier
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "fundamental.h"

double extract(uint16_t *fft, int Fs, int n) {
	double f_peaks[FPLENGTH];
	int i, j, k, m;
	for (j = 0; j < 5; j++) {
		//f_peaks[j] = strings[stringNum-1][j];
	}
	int length_f_peaks = FPLENGTH;
	int guess[FPLENGTH][5*FPLENGTH] = {{0}};
	int guessNum[FPLENGTH] = {0};
	double int_ratio_threshold = .05;
	int modeNums[50];
	int modeMax;
	int mode;
	double fund_sum = 0;
	double fundamental;
//	double ratio;
//	double lowerBound;
//	double upperBound;
    double freq_x[256]; //Frequency range
    int peakTempLength = 0; //Length of temporary peak array
    double fPeaksTemp[256] = {0}; //Temporary peak array
    double ampCutoff = 20; //Power level above which FFT value is considered a peak
    double sameFreqs[20] = {0};
    double mean;
    double num;
    
    
    //Create array of frequency values whose values correspond to those of created FFT power array
    //CHECK: how to compute power for our FFT
    for (j = 0; j < n; j++) {
        freq_x[j] = j*Fs/n;
    }

    //Find frequency values at which FFT power exceeds threshold
	for (j = 0; j <= n; j++) {
		if (fft[j] > ampCutoff) { //  && freq_x[j] < Fs/2 to eliminate higher frequencies
            fPeaksTemp[peakTempLength] = freq_x[j];
			peakTempLength++;
		}
	}
    
    //Find array indices of frequencies that are close together (the 'same' peak)
    k = 0;
    for (j = 0; j < peakTempLength - 1; j++) {
        if (fPeaksTemp[j+1] - fPeaksTemp[j] < 2)
            sameFreqs[k] = sameFreqs[k] + 1;
        else {
            k++;
            sameFreqs[k] = sameFreqs[k-1] + 1;
        }
    }
    length_f_peaks = k;
    //printf("length_f_peaks = %d\n", length_f_peaks);
    
    //Average out frequencies that are close together
    for (j = 0; j <= k; j++) {
        mean = 0;
        num = 0;
        if (j == 0) {
            for (i = 0; i <= sameFreqs[0]; i++) {
                mean = mean + fPeaksTemp[i];
                num++;
            }
        }
        else {
            for (i = sameFreqs[j-1]+1; i <= sameFreqs[j]; i++) {
                mean = mean + fPeaksTemp[i];
                num++;
            }
        }
        f_peaks[j] = mean/num;
        //printf("Peak %d: %f Hz\n", j, f_peaks[j]);
    }
    
    /*
	if ((stringNum == 3) || (stringNum == 6)) {
		length_f_peaks = 4;
	}
	if (stringNum == 5) {
		length_f_peaks = 3;
	}
     */

    //Store harmonic number guesses when peak ratio is an integer ratio
	for (j = length_f_peaks-1; j >= 0; j--) {
		for (k = j-1; k >= 0; k--) {
			for (m = (length_f_peaks+1); m > 0; m--) {
				for (n = m-1; n > 0; n--) {
					if ((f_peaks[j]/f_peaks[k] >= (double)m/(double)n - int_ratio_threshold) 						&& (f_peaks[j]/f_peaks[k] <= (double)m/(double)n + int_ratio_threshold)) {
						guess[j][guessNum[j]] = m;
						guess[k][guessNum[k]] = n;
						guessNum[j]++;
                        guessNum[k]++;
						//printf("Guess for peak %d: %d\n", j, m);
						//printf("Guess for peak %d: %d\n", k, n);
						//ratio = f_peaks[j]/f_peaks[k];
						//printf("Ratio: %f\n", ratio);
						//lowerBound = (double)m/(double)n - .05;
						//printf("Lower Bound: %f\n", lowerBound);
						//upperBound = (double)m/(double)n + .05;
						//printf("Upper Bound: %f\n", upperBound);
					}
				}
			}
		}
	}

    //Find the most popular harmonic number guess for each peak
    //Make guesses for fundamental value based on each peak divided by its harmonic number
    //Average all fundamental guesses
    num = 0;
	for (j = 0; j <= length_f_peaks; j++) {
		//printf("Peak %d:\n", j);
		memset(modeNums, 0, sizeof(modeNums)); //Set harmonic number counter bins to zero
		modeMax = 0;
		mode = 0;
		for (k = 0; k < guessNum[j]; k++) {
			modeNums[guess[j][k]]++; //Increment the proper bin for each harmonic guess
			if (modeNums[guess[j][k]] > modeMax) { //If the newly incremented bin is highest count value
				modeMax = modeNums[guess[j][k]]; //Set max count value to this
				mode = guess[j][k]; //Set new mode harmonic guess value
				//printf("Mode Max: %d\n", modeMax);
				//printf("Mode: %d\n", mode);
			}
		}
		//printf("%d\n", mode);
        if (guessNum[j] != 0) {
            fund_sum = fund_sum + f_peaks[j]/mode;
            num++;
        }
	}
	
	fundamental = fund_sum/(double)num;

    
	
	return fundamental;
}

int indexExtract(uint16_t *fft, int numPoints) {
    int i, j;
    uint16_t value = 0;
    for (i=0; i<numPoints; i++){
        if (fft[i] > value) {
            j = i;
            value = fft[i];
        }
    }
    if (value < 40){
        return 0;
    }
    return j;
}

//int *extractAll(uint16_t *fft, int numPoints) {
//    /* This function finds the 6 highest peaks in
//        the FFT of our strum; it then returns
//        them in a sorted list.  This function
//        returns the INDICES of the 6 highest peaks. */
//}