
#include <xc.h>
#include "touchCapability.h"

#define pressureThreshhold 10
#define rxplate 285 // resistance between X+ and X-

int x,y,z;
int mean=-99;

#define NUMSAMPLES 2

int * getPoint(void) {
  int samples[NUMSAMPLES];
  uint8_t i, valid;
  
  valid = 1;

  ADPCFGbits.PCFG3 = 0; // enables AN3
  TRISBbits.TRISB3 = 1; // sets AN3 to input 
  TRISDbits.TRISD8 = 1; // sets RD8 to input 
  TRISDbits.TRISD9 = 0; // sets RD9 to output 
  ADPCFGbits.PCFG2 = 1; // disables AN2
  TRISBbits.TRISB2 = 0; // sets RB2 to output 

  LATDbits.LATD9 = 1; // sets RD9 to high 
  LATBbits.LATB2 = 0; // sets RB2 to low
  
  // X+ high, X- low, read Y+
   for (i=0; i<NUMSAMPLES; i++) {
       samples[i]=-99;
        while(touchReady==0);
        samples[i] = ADC_AN3_val;
        touchReady = 0;
   }
   
   // Allow small amount of measurement noise, because capacitive
   // coupling to a TFT display's signals can induce some noise.
   if (samples[0] - samples[1] < -20 || samples[0] - samples[1] > 20) {
     valid = 0;
   } else {
     samples[1] = (samples[0] + samples[1]) >> 1; // average 2 samples
   }

   x = (1023-samples[NUMSAMPLES/2]);

   TRISDbits.TRISD9 = 1; // sets RD9 to input 
   ADPCFGbits.PCFG2 = 0; // enables AN2
   TRISBbits.TRISB2 = 1; // sets An2 to input
   ADPCFGbits.PCFG3 = 1; // disables AN3
   TRISBbits.TRISB3 = 0; // sets RB3 to output
   TRISDbits.TRISD8 = 0; // sets RD8 to output  
   
   LATDbits.LATD8 = 0;
   LATBbits.LATB3 = 1;
   
   // Y+ high, Y- low, read X-
   for (i=0; i<NUMSAMPLES; i++) {
      samples[i]=-99;
      while(touchReady==0);
      samples[i] = ADC_AN2_val; 
      touchReady=0;
   }

   // Allow small amount of measurement noise, because capacitive
   // coupling to a TFT display's signals can induce some noise.
   if (samples[0] - samples[1] < -20 || samples[0] - samples[1] > 20) {
     valid = 0;
   } else {
     samples[1] = (samples[0] + samples[1]) >> 1; // average 2 samples
   }

   y = (1023-samples[NUMSAMPLES/2]);

   // Set X+ to ground
   // Set Y- to VCC
   // Hi-Z X- and Y+
   TRISDbits.TRISD9 = 0; // sets RD9 to output 
   ADPCFGbits.PCFG3 = 0; // enables AN3
   TRISBbits.TRISB3 = 1; // sets AN3 to input

   LATDbits.LATD9 = 0;
   LATDbits.LATD8 = 1;
  
   // Y- high, X+ low, read Y+ and X-
   int z1, z2;
   z1=-99;
   while(touchReady==0);
   z1 = ADC_AN2_val;  
   z2 = ADC_AN3_val;
   touchReady = 0;
   
   if (rxplate != 0) {
     float rtouch;
     rtouch = z2;
     rtouch /= z1;
     rtouch -= 1;
     rtouch *= x;
     rtouch *= rxplate;
     rtouch /= 1024;
     
     z = rtouch;
   } else {
     z = (1023-(z2-z1));
   }

   if (! valid) {
     z = 0;
   }

   coords[0] = x;
   coords[1] = y;
   coords[2] = z;
   
   return coords;
}

